var ads = new Ads();

function Ads() {
	var ads = this;
	this.admobid = null;
	this.adShowing = false;
	this.interstitial = null;
	
	this.isAdShowing = function() {
		return ads.adShowing;
	};
	
	this.setAdShowing = function(value) {
		ads.adShowing = value;
	};

	this.runInterstitial = function() {
		if(!config.isTesting) window.FirebasePlugin.logEvent("log", {content_type: "notice", item_id: "ad_get_perc"});

		if(config.isTesting === true) {
			console.log("Ad Testing: Enabled");
			ads.prepareInterstitial();
			return;
		}

		$.ajax(config.apiPath + "perc.php", {
			type: 'GET',
			timeout: 6000,
			cache: false,
			success: function(result) {
				if(ads.showRandomAd(parseInt(result))) {
					ads.prepareInterstitial().then(function(result) {
						return result;
					});
				}
			},
			error: function() {
				ads.prepareInterstitial().then(function(result) {
					return result;
				});
			}
		});
	};
	
	this.prepareInterstitial = function() {
		if(!config.isTesting) window.FirebasePlugin.logEvent("log", {content_type: "notice", item_id: "ad_request"});
		var id = (!config.isTesting) ? config.admob.prod : config.admob.testInterstitial;

		return new Promise(async function(resolve, reject) {
			if(ads.interstitial === null) {
				await admob.start();

				admob.setAppVolume(0);
				
				ads.interstitial = new admob.InterstitialAd({
					adUnitId: id
				});

				//document.addEventListener('admob.interstitial.show', ads.show);
				document.addEventListener('admob.interstitial.dismiss', ads.dismiss);
				await ads.interstitial.load();
				await ads.interstitial.show();
			} else {
				await ads.interstitial.load();
				await ads.interstitial.show();
			}
			resolve(true);
		});
	};

	/*this.show = async function() {
		ads.setAdShowing(true);
	};*/

	this.dismiss = async function() {
		ads.setAdShowing(true);
	};
	
	this.showRandomAd = function(perc) {
		var num = Math.floor(Math.random() * 100) + 1;
		if (num <= perc) {
			return true;
		}
		return false;
	};
}