var radarCompass = new RadarCompass();

function RadarCompass() {
    var radarCompass = this;
	this.watch = null;

	this.startRadarCompass = function() {
		localforage.getItem(config.storePrefix + "compassEnabled").then(function(compassEnabled) {
			switch(compassEnabled) {
				case "false":
					radarCompass.stop();
					break;
				case "true":
					radarCompass.start();
					break;
				default:
					localforage.setItem(config.storePrefix + "compassEnabled", "false");
					radarCompass.stop();
					break;
			}
		});
	};

	this.toggleRadarCompass = function() {
		localforage.getItem(config.storePrefix + "compassEnabled").then(function(compassEnabled) {
			switch(compassEnabled) {
				case "true":
					compassEnabled = "false";
					break;
				case "false":
					if(!config.isTesting) window.FirebasePlugin.logEvent("user_action", {content_type: "menu", item_id: "compass-on"});
					compassEnabled = "true";
					break;
				default:
					compassEnabled = "true";
					break;
			}
			localforage.setItem(config.storePrefix + "compassEnabled", compassEnabled).then(function(result) {
				radarCompass.startRadarCompass();
			});
		});
	};

	this.start = function() {
		localforage.getItem(config.storePrefix + "calibrationMessageShown").then(function(shown) {
			if(shown != "true") {
				localforage.setItem(config.storePrefix + "calibrationMessageShown", "true");
				navigator.notification.alert("Cこう正のリクエストをoffにするには、方向指示をoffに設定します。", radarCompass.compassWatch, "こう正", 'Ok');
			}
			else {
				radarCompass.compassWatch();
			}
		});
	};

	this.compassWatch = function() {
		$("#radar-compass").show();

		if(radarCompass.watch === null) {
			$("#compass-text").html("&nbsp;ON 方向指示");
			radarCompass.watch = navigator.compass.watchHeading(function(heading) {
				var degs = heading.magneticHeading;

				$("#radar-compass").css({
					"transform": "rotate(" + degs + "deg)",
					"-webkit-transform": "rotate(" + degs + "deg)"
				});
			},
			function(error) {
				radarCompass.stop();
			}, {
				frequency: 50
			});
		}
	};

	this.stop = function() {
		$("#compass-text").html("&nbsp;OFF 方向指示");
		$("#radar-compass").hide();
	
		if(radarCompass.watch !== null) {
			navigator.compass.clearWatch();
			radarCompass.watch = null;
		}
	};
}
