var htmlForecast = new HTMLForecast();

function HTMLForecast() {
	var ht = this;

	this.getHTML = function(i) {
		var i_day = i * 2;
		var i_night = (i * 2) + 1;

		return '<li class="forecast-item">' +
		'<div class="forecast-summary">' +
		'<div class="forecast-icon"><i class="wi wi-' + twc.forecast_DayPart('_wi_icon', i_day) + '"></i></div>' +
		'</div>' + 
		'<div class="forecast-text">' +
		'<div class="forecast-day">' + ht.getDay(i) + ' ' + ht.getDateText(i) + '</div>' +
		'<div class="forecast-desc">' + twc.forecast_DayPart('wxPhraseLong', i_day) + '</div></div>' +
		'<div class="forecast-temp">' + twc.forecast('temperatureMax', i) + '&deg; ' + twc.forecast('temperatureMin', i) + '&deg; ' + '</div>' +
		'<div class="forecast-details">' +
		'<div class="forecast-section">' +
		'<div class="forecast-section-icon"><i class="wi wi-rain"></i></div><div class="forecast-section-details">' +
		'<div class="forecast-row">' +
		'<div class="forecast-col rainleft">' +
		'<div class="forecast-prop-key">湿度</div></div>' +
		'<div class="forecast-col rainright">' +
		'<div class="forecast-prop-value">' + twc.forecast_DayPart('relativeHumidity', i_day) + '%</div></div></div>' +
		'<div class="forecast-row">' +
		'<div class="forecast-col rainleft">' +
		'<div class="forecast-prop-key">可能降雨量</div></div>' +
		'<div class="forecast-col rainright">' +
		'<div class="forecast-prop-value">' + Math.round(twc.forecast('qpf', i)) + ' mm</div></div></div></div></div>' +
		'<div class="forecast-section space">' +
		'<div class="forecast-section-icon"><i class="wi wi-sunrise"></i></div><div class="forecast-section-details">' +
		'<div class="forecast-row">' +
		'<div class="forecast-col rainleft">' +
		'<div class="forecast-prop-key">日の出</div></div>' +
		'<div class="forecast-col rainright">' +
		'<div class="forecast-prop-value">' + ht.getSunrise(i) + '</div></div></div>' +
		'<div class="forecast-row">' +
		'<div class="forecast-col rainleft">' +
		'<div class="forecast-prop-key">日没</div></div>' +
		'<div class="forecast-col rainright">' +
		'<div class="forecast-prop-value">' + ht.getSunset(i) + '</div></div></div></div></div>' +
		'<div class="forecast-heading space"><i class="wi wi-day-sunny"></i> 日中</div>' +
		'<div class="forecast-row-text">' +
		'<div class="forecast-col full long-text">' +
		'<div class="forecast-prop-value long-text">' + twc.forecast_DayPart('narrative', i_day) + '</div></div></div>' +
		'<div class="forecast-heading"><i class="wi wi-night-clear"></i> 夜</div>' +
		'<div class="forecast-row-text">' +
		'<div class="forecast-col full long-text">' +
		'<div class="forecast-prop-value long-text">' + twc.forecast_DayPart('narrative', i_night) + '</div></div></div>';
	};

	this.getDay = function(i) {
		return translate(twc.forecast('dayOfWeek', i).toLowerCase());
	};

	this.getDateText = function(i) {
		var time = moment(twc.forecast('validTimeLocal', i));
		return translate(time.format("MMM")) + " " + time.format("D") + "日";
	};

	this.getSunrise = function(i) {
		var time = moment(twc.forecast('sunriseTimeLocal', i));
		return time.format("h:mm a");
	}

	this.getSunset = function(i) {
		var time = moment(twc.forecast('sunsetTimeLocal', i));
		return time.format("h:mm a");
	}

	this.getWind = function(wspd, wdir, wdir_cardinal) {
		if(twc.v2obs('wspd') == "0") {
			return '<span class="text">落ち着く</span>';
		}
		var windDirection = translate(twc.v2obs('wdir_cardinal'));
		return '<i class="wi wi-wind from-' + twc.v2obs('wdir') + '-deg"></i><span class="text"> ' + windDirection + ' ' + twc.v2obs('wspd') + ' m/s';
	};
}