var htmlToday = new HTMLToday();

function HTMLToday() {
	var ht = this;

this.getHTML = function() {
		var html = '<li class="forecast-item">' +
		'<div class="forecast-summary">' +
		'<div class="forecast-icon"><i class="wi wi-' + twc.today_DayPart('_wi_icon') + '"></i></div>' +
		'</div>' + 
		'<div class="forecast-text">' +
		'<div class="forecast-day">' + ht.getDay() + ' ' + ht.getDateText() + '</div>' +
		'<div class="forecast-desc">' + twc.today_DayPart('wxPhraseLong') + '</div></div>' +
		'<div class="forecast-temp">' + ht.getTemperatureMax() + twc.today('temperatureMin') + '&deg;' + '</div>' +
		'<div class="forecast-details">' +
		'<div class="forecast-section">' +
		'<div class="forecast-section-icon"><i class="wi wi-thermometer"></i></div><div class="forecast-section-details">' +
		'<div class="forecast-row">' +
		'<div class="forecast-col currentleft">' +
		'<div class="forecast-prop-key">現在</div></div>' +
		'<div class="forecast-col currentright">' +
		'<div class="forecast-prop-value">' + twc.v2obs('temp') + '&deg;</div></div></div>' +
		'<div class="forecast-row">' +
		'<div class="forecast-col currentleft">' +
		'<div class="forecast-prop-key">体感気温</div></div>' +
		'<div class="forecast-col currentright">' +
		'<div class="forecast-prop-value">' + twc.v2obs('feels_like') + '&deg;</div></div></div>' +
		'<div class="forecast-row">' +
		'<div class="forecast-col currentleft">' +
		'<div class="forecast-prop-key">湿度</div></div>' +
		'<div class="forecast-col currentright">' +
		'<div class="forecast-prop-value">' + twc.v2obs('rh') + '%</div></div></div>' +
		'<div class="forecast-row">' +
		'<div class="forecast-col currentleft">' +
		'<div class="forecast-prop-key">露点</div></div>' +
		'<div class="forecast-col currentright">' +
		'<div class="forecast-prop-value">' + twc.v2obs('dewPt') + '&deg;</div></div></div></div></div>' +
		'<div class="forecast-section space">' +
		'<div class="forecast-section-icon"><i class="wi wi-rain"></i></div><div class="forecast-section-details">' +
		'<div class="forecast-row">' +
		'<div class="forecast-col rainleft">' +
		'<div class="forecast-prop-key">降水確率</div></div>' +
		'<div class="forecast-col rainright">' +
		'<div class="forecast-prop-value">' + twc.today_DayPart('precipChance') + '%</div></div></div>' +
		'<div class="forecast-row">' +
		'<div class="forecast-col rainleft">' +
		'<div class="forecast-prop-key">可能降雨量</div></div>' +
		'<div class="forecast-col rainright">' +
		'<div class="forecast-prop-value">' + Math.round(twc.today_DayPart('qpf')) + ' mm</div></div></div></div></div>' +
		'<div class="forecast-section space">' +
		'<div class="forecast-section-icon"><i class="wi wi-strong-wind"></i></div><div class="forecast-section-details">' +
		'<div class="forecast-row">' +
		'<div class="forecast-col windleft">' +
		'<div class="forecast-prop-key">風</div></div>' +
		'<div class="forecast-col windright">' +
		'<div class="forecast-prop-value">' + ht.getWind() + '</div></div></div></div></div>' +
		'<div class="forecast-section space">' +
		'<div class="forecast-section-icon"><i class="wi wi-sunrise"></i></div><div class="forecast-section-details">' +
		'<div class="forecast-row">' +
		'<div class="forecast-col sunleft">' +
		'<div class="forecast-prop-key">紫外線</div></div>' +
		'<div class="forecast-col sunright">' +
		'<div class="forecast-prop-value">' + twc.v2obs('uv_desc') + '</div></div></div>' +
		'<div class="forecast-row">' +
		'<div class="forecast-col sunleft">' +
		'<div class="forecast-prop-key">日の出</div></div>' +
		'<div class="forecast-col sunright">' +
		'<div class="forecast-prop-value">' + ht.getSunrise() + '</div></div></div>' +
		'<div class="forecast-row">' +
		'<div class="forecast-col sunleft">' +
		'<div class="forecast-prop-key">日没</div></div>' +
		'<div class="forecast-col sunright">' +
		'<div class="forecast-prop-value">' + ht.getSunset() + '</div></div></div></div></div>';

		var dayHTML = (twc.getDayPartIndex() === 0) ? ht.getDayPartHTML('今日', 0) : '';
		var nightHTML = ht.getDayPartHTML('今夜', 1);

		html = html + dayHTML + nightHTML;
		return html;
	};

	this.getDayPartHTML = function(title, i) {
		var icon = (i === 0) ? 'wi-day-sunny' : 'wi-night-clear';
		var space = (i === 0) ? ' space' : '';
		return '<div class="forecast-heading' + space + '"><i class="wi ' + icon + '"></i> ' + title + '</div>' +
		'<div class="forecast-row-text">' +
		'<div class="forecast-col full long-text">' +
		'<div class="forecast-prop-value long-text">' + twc.forecast_DayPart('narrative', i)  + '</div></div></div>';
	};

	this.getDay = function() {
		return translate(twc.today('dayOfWeek').toLowerCase());
	};

	this.getDateText = function() {
		var time = moment(twc.today('validTimeLocal'));
		return translate(time.format("MMM")) + " " + time.format("D") + "日";
	};

	this.getTemperatureMax = function() {
		var temp = twc.today('temperatureMax');
		return (temp != "-") ? temp + '&deg; ' : '-&deg; ';
	}

	this.getSunrise = function() {
		var time = moment(twc.today('sunriseTimeLocal'));
		return time.format("h:mm a");
	}

	this.getSunset = function() {
		var time = moment(twc.today('sunsetTimeLocal'));
		return time.format("h:mm a");
	}

	this.getWind = function() {
		if(twc.v2obs('wspd') == "0") {
			return '<span class="text">落ち着く</span>';
		}
		return '<i class="wi wi-wind from-' + twc.v2obs('wdir') + '-deg"></i><span class="text"> ' + twc.v2obs('wdir_cardinal') + ' ' + twc.v2obs('wspd') + ' m/s';
	};
}