var layers = new Layers(); 

function Layers() {
	var layers = this;

    this.timestamps = [];
    this.data = [];
    this.currentTime = null;
    this.currentTimeSubtract = null;

    this.generateTimestamps = function(type) {
        layers.timestamps = [];
        layers.data = [];
        var intvl = layers.getTimeInterval(type);

        var u = moment.utc().format("YYYYMMDDHHmm");
        var c = u - (u % intvl);
        var baseTime = moment.utc(c, "YYYYMMDDHHmm");
        layers.currentTime = baseTime.format("YYYYMMDDHHmm");
        layers.currentTimeSubtract = baseTime.subtract(intvl, 'minutes').format("YYYYMMDDHHmm");

        baseTime.subtract(1, 'hour');
        var li = 120 / intvl;

        for(var i=0; i < li; i++) {
            layers.timestamps.push(baseTime.format("YYYYMMDDHHmm"));
            baseTime.add(intvl, 'minutes');
        }
    };

    this.buildLayers = function(type) {
        layers.reset();
        layers.generateTimestamps(type);


        $.each(layers.timestamps, function(key, t) {
            var b = (t > layers.currentTime) ? layers.currentTimeSubtract : t;
            var s = layers.layerURL(type, b, t);
            layers.data.push(s);
        });

        return layers.data;
    };

    this.getTimeInterval = function(type) {
        if(type == "rain") return 5;
        if(type == "thunder") return 10;
        if(type == "wind") return 10;
        if(type == "precipitation") return 10;
        if(type == "lightning") return 10;
    }

    this.layerURL = function(type, b, t) {
        if(type == "rain") return "https://www.jma.go.jp/bosai/jmatile/data/nowc/" + b + "00/none/" + t + "00/surf/hrpns/{z}/{x}/{y}.png";
        if(type == "thunder") return "https://www.jma.go.jp/bosai/jmatile/data/nowc/" + b + "00/none/" + t + "00/surf/thns/{z}/{x}/{y}.png";
        if(type == "wind") return "https://www.jma.go.jp/bosai/jmatile/data/nowc/" + b + "00/none/" + t + "00/surf/trns/{z}/{x}/{y}.png";
        if(type == "precipitation") return "https://www.jma.go.jp/bosai/jmatile/data/nowc/" + b + "00/none/" + t + "00/surf/thns/{z}/{x}/{y}.png";
        if(type == "lightning") return "https://www.jma.go.jp/bosai/jmatile/data/nowc/" + b + "00/none/" + t + "00/surf/amds_rain10m/{z}/{x}/{y}.png";
    }

    this.getTimestamp = function(i) {
        return layers.timestamps[i];
    }

    this.getTimestampLabel = function(i) {
        moment.locale('ja');
		var offset = moment().utcOffset();
		var layerDate = moment(layers.timestamps[i], "YYYYMMDDHHmm");
		layerDate.add(offset, "minutes");
		moment.locale('en');
		return layerDate.fromNow();
    };

    this.reset = function() {
        layers.timestamps = [];
        layers.data = [];
    }
};
