var locationAdd = new LocationAdd();

function LocationAdd() {
	var locationAdd = this;
	this.isAutocompleteEnabled = false;
	this.scroll = null;
	this.isRequestLimitReached = false;
	this.textLength = 0;
	
	//some reason height() not work on css selector, so added const here
	this.LIST_ITEM_HEIGHT = 60;
	this.DAILY_REQUEST_LIMIT = 200;

	this.initLocationAdd = function() {
		if(locationAdd.isAutocompleteEnabled === true) {
			return;
		}
		locationAdd.isAutocompleteEnabled = true;
		$('#location-search-input').on('input', this.showLocationResults);
	};
	
	this.showLocationResults = function(ev) {
		var searchText = $('#location-search-input:text').val();
		if(searchText.length == locationAdd.textLength) {
			return;
		}
		locationAdd.textLength = searchText.length;

		$('#location-add-scroller .list').html("");
		$('#location-add-scroller .list-item').off('touchstart');

		locationAdd.isRequestAvailable().then(function(isRequestAvailable) {
			if(!isRequestAvailable) {
				if(!locationAdd.isRequestLimitReached) {
					if(!config.isTesting) window.FirebasePlugin.logEvent("log", {content_type: "warning", item_id: "location_search_request_limit_reached"});			
					navigator.notification.alert("本日の地域検索の容量が多すぎる為検索できません", null, "地域検索の最大容量", "Ok");
					locationAdd.isRequestLimitReached = true;
				}
				return;
			}

			var searchText = $('#location-search-input:text').val();

			if(searchText.length >= 2) {
				$.ajax("http://api.geonames.org/searchJSON?lang=ja&searchlang=ja&name_startsWith=" + searchText + "&maxRows=7&username=rezzen22&country=JP&featureClass=A&featureClass=P&orderby=relevance", {
					type: 'GET',
					success: function(results) {
						if(results.geonames === undefined) {
							return;
						}

						var appendHtml = '';
						$.each(results.geonames, function(key, element) {
							appendHtml = appendHtml + '<li class="list-item ellipsis" data-name="' + element.name + '" data-lat="' + element.lat + '" data-long="' + element.lng + '"><i class="fa fa-map-marker fa-fw list-icon"></i> ' + element.name + ', ' + element.adminName1 + '</div></li>';
						});
					
						var scrollerHeight = $('#location-add-scroller').height();
						$('#location-add-scroller .list').html(appendHtml);
					
						var listHeight = scrollerHeight + (results.geonames.length - 1) * locationAdd.LIST_ITEM_HEIGHT;
						$('#location-add-scroller .list').css('height', listHeight);
					
						if(locationAdd.scroll === null) {
							locationAdd.scroll = new IScroll("#location-add-scroller", {
								scrollX: false,
								scrollY: true,
								bounce: false
							});
						}
						else {
							locationAdd.scroll.refresh();
						}
	
						locationAdd.scroll.on('scrollStart', function() {
							if(!$('#location-add-scroller').hasClass('scrolling')) {
								$('#location-add-scroller').addClass('scrolling');
							}
						});

						$('#location-add-scroller .list').on('touchend', function(ev) {
							if($('#location-add-scroller').hasClass('scrolling')) {
								$('#location-add-scroller').removeClass('scrolling');
							}
						});
					
						$('#location-add-scroller .list-item').on('touchstart', function() {
							$('#location-search-input').blur();
						});
						$('#location-add-scroller .list-item').on('touchend', locationAdd.setLocationBookmark);
					},
					error: function() {
						console.log("Could not retrieve list of locations");
					}
				});
			}
		});
	};
	
	this.setLocationBookmark = function(ev) {
		if($('#location-add-scroller').hasClass('scrolling')) {
			return;
		}
		var name = $(this).data('name');

		locationManager.addLocation($(this).data('name'), $(this).data('lat'), $(this).data('long')).then(function(results) {
			$("#location-search-input:text").val("");
			$('#location-add-scroller .list').html("");
			locationList.populateLocationList();
			menu.showLocationBookmarks(true);
			locationAddViewDone();
		});
	};
	
	this.disableLocationAdd = function() {
		$('#location-search-input').off('input');
		$('#location-search-input').blur();
		$("#location-search-input:text").val("");
		$('#location-add-scroller .list').html("");
		$('#location-add-scroller .list-item').off('touchstart');
		locationAdd.isAutocompleteEnabled = false;
	};
	
	this.isRequestAvailable = function() {
		return localforage.getItem(config.storePrefix + "requestLimitCounter").then(function(requestLimitCounter) {
			var currentDate = moment().format("YYYYMMDD");
			var refreshFlag = false;
			if(requestLimitCounter == null) {
				refreshFlag = true;
			}
			else {
				requestLimitCounter = JSON.parse(requestLimitCounter);
				if(requestLimitCounter[currentDate] === undefined) {
					refreshFlag = true;
				}
			}
			
			if(refreshFlag) {
				this.isRequestLimitReached = false;
				requestLimitCounter = {};
				requestLimitCounter[currentDate] = 0;
			}
			
			if(requestLimitCounter[currentDate] > locationAdd.DAILY_REQUEST_LIMIT) {
				return false;
			}
			
			requestLimitCounter[currentDate] = requestLimitCounter[currentDate] + 1;
			localforage.setItem(config.storePrefix + "requestLimitCounter", JSON.stringify(requestLimitCounter));
			return true;
		});
	};
}

$('.location-add .view-nav').on('touchstart', locationAddViewDone);

function locationAddViewDone() {
	locationAdd.disableLocationAdd();
	$('.location-add').removeClass('show');
	
	$('.location-add').on("transitionend webkitTransitionEnd oTransitionEnd MSTransitionEnd", function(){
		$('.location-add').fadeOut(0);
		$('.location-add').off("transitionend webkitTransitionEnd oTransitionEnd MSTransitionEnd");
	});
}
