var locationList = new LocationList();

function LocationList() {
    var locationList = this;
	this.scroll = null;
	
	//some reason height() not work on css selector, so added const here
	this.LIST_ITEM_HEIGHT = 60;

	this.populateLocationList = function() {
		$('.list-help').hide();
		$('.location-list .list').html("");
		$('.location-delete').off('touchend');

		localforage.getItem(config.storePrefix + "storeLocation").then(function(storeLocation) {
			if(storeLocation === null) {
				$('.list-help').show();		
				return;
			}
			storeLocation = JSON.parse(storeLocation);		
			
			var scrollItemCounter = 0;
			var appendHtml = '';
			
			if (storeLocation.length == 0) {
				$('.list-help').show();
				return;
			}

			$.each(storeLocation, function(key, element) {
				appendHtml = appendHtml + '<li class="list-item"><div class="location-delete" data-id="' + element.id + '"><i class="fa fa-close fa-fw"></i></div>' + 
					'<i class="fa fa-star fa-fw list-icon"></i><div class="location-name ellipsis">' + element.name + '</div></li>';
				scrollItemCounter++;
			});
			
			$('.location-list .list').html(appendHtml);
			var locationListHeight = locationList.LIST_ITEM_HEIGHT * storeLocation.length;
			$('#location-list-scroller .list').css("height", locationListHeight);
			
			if(locationList.scroll === null) {
				locationList.scroll = new IScroll("#location-list-scroller", {
					scrollX: false,
					scrollY: true,
					bounce: false
				});
			}
			else {
				locationList.scroll.refresh();
			}

			$('.location-delete').on('touchstart', function(ev) {
				var selectedLocation = $(this);
				ev.preventDefault();
				locationManager.deleteLocation(selectedLocation.data('id')).then(function(results) {
					selectedLocation.parent(".list-item").fadeOut('fast', function() {
						locationManager.setBookmarkStatus();
						locationList.populateLocationList();
						menu.showLocationBookmarks();
					});
				});
			});
		});
	};
	
	this.locationBookmarkHelpMsg = function() {
		var msg = '<div class="list-help">\'<i class="fa fa-plus fa-fw"></i>\'の印をタッチで新しい地域をブックマークすることができます。</div>';
		$('#location-list-scroller').html(msg);
	};
}

$('.view-add').on('touchstart', function(ev) {
	localforage.getItem(config.storePrefix + "storeLocation").then(function(storeLocation) {
		if(storeLocation !== null) {
			storeLocation = JSON.parse(storeLocation);
			if(storeLocation.length >= 20) {
				if(!config.isTesting) window.FirebasePlugin.logEvent("log", {content_type: "warning", item_id: "location_bookmark_limit_reached"});
				navigator.notification.alert("最大で20箇所の地域がブックマークできます。", null, "より多くの地域をブックマークできます。", "Ok");
				return;
			}
		}

		$('.location-add').fadeIn(0, function() {
			$('.location-add').addClass('show');
			locationAdd.initLocationAdd();
		});
	});
});

$('.location-list .view-done').on('touchstart', locationListViewDone);

function locationListViewDone() {
	$('.location-list').removeClass('show');
	$('.location-list').on("transitionend webkitTransitionEnd", function(){
		$('.location-list').fadeOut(0);
		$('.location-list').off("transitionend webkitTransitionEnd");
	});
}
