var locationManager = new LocationManager();

function LocationManager() {
	var manager = this;
	this.currentLocation = null;

	this.moveToLocation = function (location) {
		localforage.setItem(config.storePrefix + "staticLocation", "true");
		userLat = location.lat;
		userLong = location.long;
		userLocation = location.name;
		rainRadar.resetMapViewFlag = location.resetMap;
		rrm.isPaused = false;

		$("#play-button").removeClass("fa-play").addClass("fa-pause");

		rainRadar.setLocationState(rainRadar.locationStateEnum.USER_LOCATION);
		rainRadar.getUserLocation();
	};

	this.resetRadarType = function () {
		radarType = "rain";
	};

	this.useCurrentLocation = function () {
		localforage.setItem(config.storePrefix + "staticLocation", "false");
		radarType = "rain";

		rainRadar.resetMapViewFlag = true;
		rrm.isPaused = false;
		$("#play-button").removeClass("fa-play").addClass("fa-pause");

		userLocation = null;
		rainRadar.setLocationState(rainRadar.locationStateEnum.USER_LOCATION);
		rainRadar.getUserLocation();
	};

	this.setBookmarkStatus = function(location) {
		manager.currentLocation = (typeof location !== 'undefined') ? location : manager.currentLocation;
		manager.isLocationBookmarked(manager.currentLocation.name).then(function(result) {
			if(result === true) {
				manager.locationBookmarked();
			}
			else {
				manager.locationNotBookmarked();
			}
			$(".bookmark").show();
		});
	};

	this.isLocationBookmarked = function(locationName) {
		return localforage.getItem(config.storePrefix + "storeLocation").then(function(storeLocation) {
			if(storeLocation === null) {	
				return false;
			}
			storeLocation = JSON.parse(storeLocation);	
			
			var foundLocation = false;
			$.each(storeLocation, function(key, element) {
				if(element.name.toLowerCase() === locationName.toLowerCase()) {
					foundLocation = true;
				}
			});
			return foundLocation;
		});
	};

	this.locationBookmarked = function(location) {
		$("#bookmark-star").removeClass("fa-star-o").addClass("fa-star");
	};
	
	this.locationNotBookmarked = function() {
		$("#bookmark-star").removeClass("fa-star").addClass("fa-star-o");
	};

	this.addCustomBookmark = function() {
		localforage.getItem(config.storePrefix + "storeLocation").then(function(storeLocation) {
			if(storeLocation !== null) {
				storeLocation = JSON.parse(storeLocation);
				if(storeLocation.length >= 20) {
					window.FirebasePlugin.logEvent("log", {content_type: "warning", item_id: "location_search_request_limit_reached"});
					navigator.notification.alert("Sorry, maximum of 20 location bookmarks.", null, "Maximum Location Bookmarks", "Ok");
					return;
				}
			}

			manager.addLocation(manager.currentLocation.name, manager.currentLocation.lat, manager.currentLocation.long).then(function(results) {
				$("#bookmark-star").removeClass("fa-star-o").addClass("fa-star");
				locationList.populateLocationList();
				menu.showLocationBookmarks(true, true);
			});

		});
	};

	this.deleteCustomBookmark = function() {
		manager.deleteLocationByName(manager.currentLocation.name).then(function(results) {
			$("#bookmark-star").removeClass("fa-star").addClass("fa-star-o");
			locationList.populateLocationList();
			menu.showLocationBookmarks(false, true);
		});
	};

	this.addLocation = function(name, lat, long) {
		return localforage.getItem(config.storePrefix + "storeLocation").then(function(storeLocation) {
			var newStoreLocation = [];
			if(storeLocation !== null) {
				storeLocation = JSON.parse(storeLocation);	
				newStoreLocation = storeLocation;	
			}
			
			//Check bookmark does not already exist
			var found = false;
			$.each(newStoreLocation, function(key, element) {
				if(element.lat === lat && element.long === long) {
					found = true;
					return false;
				}
			});
			if(found) { return; }
			
			// newID - 10 is the id multiplier. 100 is offset so not to conflict with capital city IDs
			var newId = ((newStoreLocation.length + 1) * 10) + 100;
			newStoreLocation.push({
				id: newId,
				name: name,
				lat: lat,
				long: long
			});

			localforage.setItem(config.storePrefix + "storeLocation", JSON.stringify(newStoreLocation)).then(function(results) {
				return true;
			});
		});
	};

	this.deleteLocation = function(id) {
		return localforage.getItem(config.storePrefix + "storeLocation").then(function(storeLocation) {
			if(storeLocation === null) {
				return;
			}
			storeLocation = JSON.parse(storeLocation);		
			
			storeLocation = storeLocation.filter(function(element) {
				return element.id != id;
			});

			return localforage.setItem(config.storePrefix + "storeLocation", JSON.stringify(storeLocation)).then(function(results) {
				locationManager.setBookmarkStatus();				
				return true;
			});
		});
	};

	this.deleteLocationByName = function(name) {
		return localforage.getItem(config.storePrefix + "storeLocation").then(function(storeLocation) {
			if(storeLocation === null) {
				return;
			}
			storeLocation = JSON.parse(storeLocation);
			
			storeLocation = storeLocation.filter(function(element) {
				return element.name.toLowerCase() != name.toLowerCase();
			});

			return localforage.setItem(config.storePrefix + "storeLocation", JSON.stringify(storeLocation)).then(function(results) {
				locationManager.setBookmarkStatus();
				return true;
			});
		});
	};
}
