var radarData = null;
var weatherData = null;

var userLat = null;
var userLong = null;
var userLocation = null;

var intervalRefreshData = null;
var timeoutUserLocationRetry = null;
var timeoutUserLocationPause = null;
var timeoutUserLocationOnResume = null;

var radarType = "rain";
var appLoaded = false;

$(document).ready(function() {
   	document.addEventListener("deviceready", onDeviceReady, false);
    document.addEventListener("pause", onPause, false);
    document.addEventListener("resume", onResume, false);
});

function onDeviceReady() {
	if(config.isTesting) {
		$(".debug").text("isTesting");
		$(".debug").show();
	}

	localforage.config(config.localforageConfig);
	localforage.getItem(config.storePrefix + "user_id").then(function(userID) {
		if(userID === null) {
			userID = helper.generateUserID();
			localforage.setItem(config.storePrefix + "user_id", userID);
		}
		if(!config.isTesting) window.FirebasePlugin.setUserId(userID);
		onResume();
	});
}

function onResume() {
	try {
		if(!window.isTablet) {
			window.screen.orientation.lock('portrait');
		}
	}
	catch(ev) {}

	try {
		if(window.MobileAccessibility){
        	window.MobileAccessibility.usePreferredTextZoom(false);
    	}
	}
	catch(ev) {}

    if(ads.isAdShowing() === false) {
		if(rrm !== null && (typeof rrm != 'undefined')) {
			rrm.isPaused = false;
		}
		$("#play-button").removeClass("fa-play").addClass("fa-pause");

        if(appLoaded) {
			timeoutUserLocationOnResume = setTimeout(function() {
				rainRadar.getUserLocation();
			}, config.timer.userLocationPause);
		}
		else {
			rainRadar.getUserLocation();
			appLoaded = true;
		}

		ratings.showRateDialog().then(function(showRateDialog) {
			if(showRateDialog === false) {
				adsManager.runAds();
			}
		});

		menu.showLocationBookmarks();

		if($('.forecast').hasClass('show')) {
			forecast.showForecast();
		}

		radarCompass.startRadarCompass();
    }
    else {
		ads.setAdShowing(false);
		rainRadar.setIntervalRefreshData();
    }
}

function onPause() {
	clearTimers();

	if($('.forecast').hasClass('show')) {
		$('.forecast').hide();
		$('.forecast').removeClass('show');
	}
}

function clearTimers() {
	if(intervalRefreshData !== null) {
        clearInterval(intervalRefreshData);
        intervalRefreshData = null;
    }

    if(timeoutUserLocationRetry !== null) {
        clearTimeout(timeoutUserLocationRetry);
        timeoutUserLocationRetry = null;
    }

	if(timeoutUserLocationPause !== null) {
        clearTimeout(timeoutUserLocationPause);
        timeoutUserLocationPause = null;
    }

	if(timeoutUserLocationRetry !== null) {
        clearTimeout(timeoutUserLocationRetry);
        timeoutUserLocationRetry = null;
    }
}

var scrollValue = 0;
var scrollAdjusted = 0;

$(window).resize(function() {
	if($(window).height() == 812) {
		$(".summary").css("padding-top", "46px");
		$(".summary").css("padding-bottom", "18px");
	}
	else if($(window).height() >= 665) {
		$(".summary").css("padding-top", "36px");
		$(".summary").css("padding-bottom", "12px");
	}
	else {
		$(".summary").css("padding-top", "28px");
		$(".summary").css("padding-bottom", "12px");
	}
	rainRadar.resize();
});

$(".radar-select").on("touchstart", function(ev){
    ev.preventDefault();
    if (!$(this).hasClass("selected")) {
        $(".selected").removeClass("selected");
		$("#radar-marker").removeClass("transition");
        $(this).addClass("selected");
		
        $(".radar-loader").show();
		
		rrm.isPaused = false;
		$("#play-button").removeClass("fa-play").addClass("fa-pause");
		
		radarType = $(this).data("type");

		if(!config.isTesting) window.FirebasePlugin.logEvent("user_action", {content_type: "main", item_id: 'select-' + radarType});
        rainRadar.getRainRadar(false);
    }
});

$('.summary').on('touchstart', function(ev) {
	if($('.view-body').hasClass('open-menu') === false) {
		ev.stopPropagation();

		$('.forecast').show(0, function() {
			$('.forecast').on("transitionend webkitTransitionEnd", function(){
				$('.forecast').off("transitionend webkitTransitionEnd");
				forecast.scrollRefresh();
			});
			$('.forecast').addClass('show');
		});
		if(!config.isTesting) window.FirebasePlugin.logEvent("user_action", {content_type: "forecast", item_id: "forecast_open"});
	}
});

$(".bookmark").on("touchstart", function(ev) {
	ev.stopPropagation();
	if($("#bookmark-star").hasClass("fa-star-o")) {
		locationManager.addCustomBookmark();
	}
	else {
		locationManager.deleteCustomBookmark();
	}
});

$(".popup").on("touchstart", function(ev) {
	ev.preventDefault();
	rainRadar.hidePopUp();
});

$('.popup-toggle').on('touchstart', function(ev) {
	ev.stopPropagation();
	menuEvents.openMenu();
});

