var marker = new Marker();

function Marker() {
    var marker = this;
	this.zoomMultiplier = 1;
	this.titleHeightPerc = 0.0419;
	
    this.regionNowcastLong = 6.672;
    this.regionNowcastLat = 3.474;

	this.regionForecastLong = 6.672;
    this.regionForecastLat = 2.374;

	this.nationalNowcastLong = 39.1;
	this.nationalNowcastLat = 25.4;

	this.nationalForecastLong = 39.1;
	this.nationalForecastLat = 18.4;

	this.readingLong = 4.023;
	this.readingLat = 2.697;

    this.setPosition = function() {
		var multiLong = marker.getLong() / marker.zoomMultiplier;
		var multiLat = marker.getLat() / marker.zoomMultiplier;
		var titleHeight = $(window).width() * marker.titleHeightPerc;
        var radarWidth = $(".baseelement").width();

		var radarHeight;

		switch(radarType) {
			case "infrared":
			case "weather_chart":
				$("#radar-marker").hide();
				break;
			default:
				radarHeight = $(".baseelement").height() - titleHeight;
				$("#radar-marker").show();
		}
		
		var left = radarData.long - multiLong / 2;
        var top = radarData.lat + multiLat / 2;

		var diffFromLeftToUserLong = userLong - left;
		var diffFromTopToUserLat = top - userLat;

		var percFromLeftToUserLong = diffFromLeftToUserLong / multiLong;
		var percFromTopToUserLat = diffFromTopToUserLat / multiLat;
		
		var leftOffset = percFromLeftToUserLong * radarWidth - 18;
		
		var topOffset = percFromTopToUserLat * radarHeight + titleHeight - 18;        
		$("#radar-marker").css({"left": leftOffset, "top": topOffset, "opacity": "1"});
    };
	
	this.getLong = function() {
		switch(radarType) {
			case "rain_region_nowcast":
				return marker.regionNowcastLong;
			case "rain_national_nowcast":
				return marker.nationalNowcastLong;
			default:
				return marker.readingLong;
		}
	};
	
	this.getLat = function() {
		switch(radarType) {
			case "rain_region_nowcast":
				return marker.regionNowcastLat;
			case "rain_national_nowcast":
				return marker.nationalNowcastLat;
			default:
				return marker.readingLat;
		}
	};
	
	this.setZoomMultipler = function(zoom) {
		marker.zoomMultiplier = zoom;
	};
}