var menuEvents = new MenuEvents();

function MenuEvents() {
	var menuEvents = this;

	this.compass = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		radarCompass.toggleRadarCompass();
	};

	this.helpfulHints = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		menuEvents.closeMenu();
		rainRadar.showPopUp();

		if(!config.isTesting) window.FirebasePlugin.logEvent("user_action", {content_type: "menu", item_id: "help_open"});
	};

	this.reviewApp = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		menuEvents.closeMenu();

		ratings.reviewApp();
		if(!config.isTesting) window.FirebasePlugin.logEvent("user_action", {content_type: "menu", item_id: "review_app_open"});
	};

	this.emailSupport = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		window.open("mailto:" + config.supportEmail + "?subject=サポートをリクエスト (" + config.platform + " " + config.version + ")", "_system");
		if(!config.isTesting) window.FirebasePlugin.logEvent("user_action", {content_type: "menu", item_id: "support_email_open"});
	};

	this.facebook = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		window.open(config.facebookLink, "_system", "location=no");
		if(!config.isTesting) window.FirebasePlugin.logEvent("user_action", {content_type: "menu", item_id: "facebook_page_open"});
	};

	this.makePurchase = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		inAppPurchase.makePurchase();
		menuEvents.closeMenu();

		if(!config.isTesting) window.FirebasePlugin.logEvent("user_action", {content_type: "menu", item_id: "purchase"});
	};

	this.restorePurchase = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();
	
		inAppPurchase.restorePurchase();
		menuEvents.closeMenu();

		if(!config.isTesting) window.FirebasePlugin.logEvent("user_action", {content_type: "menu", item_id: "restore_purchase"});
	};

	this.useCurrentLocation = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		locationManager.useCurrentLocation();
		menuEvents.closeMenu();
	};

	this.openLocation = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		$('.radar-loader').show();
		$(".radar-select").removeClass("selected");
		$(".standard").addClass("selected");

		locationManager.resetRadarType();
		locationManager.moveToLocation({
			lat: $(this).data('lat'),
			long: $(this).data('long'),
			name: $(this).data('name'),
			resetMap: true,
		});
		menuEvents.closeMenu();
	};

	this.editLocation = function(ev) {
		if($('#view-menu-scroller').hasClass('scrolling')) return;
		ev.preventDefault();

		$('.location-list').fadeIn(0, function() {
			locationList.populateLocationList();
			$('.location-list').addClass('show');
		});
	};

	this.openMenu = function(ev) {
		$('.view-body').addClass('open-menu');
		$('#popup-toggle-img').removeClass('fa-bars').addClass('fa-close');
		$('.popup-toggle').off('touchstart');
		$('.view-body').on('touchstart', function(ev) {
			ev.stopPropagation();
			menuEvents.closeMenu();
		});
	};

	this.closeMenu = function(ev) {
		$('.view-body').removeClass('open-menu');
		$('#popup-toggle-img').removeClass('fa-close').addClass('fa-bars');
		$('.view-body').off('touchstart');

		$('.popup-toggle').on('touchstart', function(ev) {
			ev.stopPropagation();
			menuEvents.openMenu();
		});
	};
}

// Events
$('.compass').on('touchend', menuEvents.compass);
$('.helpful-hints').on('touchend', menuEvents.helpfulHints);
$('.review-app').on('touchend', menuEvents.reviewApp);
$('.email-support').on('touchend', menuEvents.emailSupport);
$('.facebook').on('touchend', menuEvents.facebook);
$(".make-purchase").on("touchend", menuEvents.makePurchase);
$(".restore-purchase").on("touchend", menuEvents.restorePurchase);
$('.use-current-location').on('touchend', menuEvents.useCurrentLocation);
$('.location').on('touchend', menuEvents.openLocation);
$('.edit-locations').on('touchend', menuEvents.editLocation);
