var menu = new ViewMenu();

function ViewMenu() {
	var viewMenu = this;
	this.scroll = null;
	this.isShowingMenu = false;
	this.isHideOnPurchaseSet = false;
	
	//some reason height() not work on css selector, so added const here
	this.MENU_ITEM_HEIGHT = 46;
	this.MENU_HEIGHT_PADDING = 40;

	this.showMenu = function() {
		if(viewMenu.isShowingMenu === true) {
			return;
		}

		inAppPurchase.hasPurchased().then(function(hasPurchased) {
			viewMenu.setAboutText(hasPurchased);
		});

		viewMenu.isShowingMenu = true;
		$('.view-menu').css('opacity', 1);

		viewMenu.scroll = new IScroll("#view-menu-scroller", {
			scrollX: false,
			scrollY: true,
			bounce: false,
			preventDefault: (config.platform == "ios") ? true : false
		});

		viewMenu.scroll.on('scrollStart', function() {
			$('#view-menu-scroller').addClass('scrolling');
		});

		$('.view-menu').on('touchend', function(ev) {
			$('#view-menu-scroller').removeClass('scrolling');
		});
	};
	
	this.showLocationBookmarks = function() {
		$('.stored-location').off('touchend');
		$('.edit-location').off('touchend');

		localforage.getItem(config.storePrefix + "storeLocation").then(function(storeLocation) {
			if(storeLocation === null) {
				$("#recent-locations").html("");
				viewMenu.setViewMenuHeight();
				return;
			}
			storeLocation = JSON.parse(storeLocation);
			
			var appendHtml = '';
			$.each(storeLocation, function(key, element) {
				appendHtml = appendHtml + '<li class="stored-location ellipsis" data-id="' + element.id + '" data-name="' + element.name + '" data-lat="' + element.lat + '" data-long="' + 
						element.long + '"><i class="fa fa-star fa-fw"></i> ' + element.name + '</li>';
			});
			$('.stored-location').remove();
			$('#location-bookmarks').prepend(appendHtml);

			// Adjust menu scroll size to accomodate location bookmarks
			viewMenu.setViewMenuHeight();
			if(viewMenu.scroll !== null) {
				viewMenu.scroll.refresh();
			}

			$('.stored-location').on('touchend', menuEvents.openLocation);
			$('.edit-location').on('touchend', menuEvents.editLocation);
		});
	};
	
	this.setViewMenuHeight = function() {
		var viewMenuHeight = $('#view-menu-height').height();
		$('.view-menu').css('height', (viewMenuHeight + viewMenu.MENU_HEIGHT_PADDING));
		if(viewMenu.scroll !== null) {
			viewMenu.scroll.refresh();
		}
	};

	this.hideOnPurchase = function() {
		$(".popup").fadeOut('fast');
		$(".hide-on-purchase").hide();
		viewMenu.setAboutText(true);
		if(viewMenu.isHideOnPurchaseSet === false) {
			viewMenu.isHideOnPurchaseSet = true;
			viewMenu.setViewMenuHeight();
		}
	}

	this.setAboutText = function(hasPurchased) {
		var about_text = "v" + config.version;
		if(hasPurchased) {
			about_text = about_text + " &middot; Ad Free";
		}
		$('.about').html(about_text);
	}
}