var twc = new TWC();

function TWC() {
	var twc = this;
	this.data = null;
	this.dayPartIndex = null;

	this.setData = function(payload) {
		twc.data = payload;
		twc.setDayPartIndex();
	};

	this.isDataLoaded = function() {
		return (this.data !== null) ? true : false;
	}

	this.getDayPartIndex = function() {
		return this.dayPartIndex;
	};

	this.setDayPartIndex = function() {
		var data = twc.data['v3-wx-forecast-daily-10day'].daypart[0].dayOrNight[0];
		this.dayPartIndex = ((data !== undefined) && (data !== null)) ? 0 : 1;
	};

	this.getLocationName = function() {
		return twc.checkLocationNull(twc.data['v3-location-point'].location.displayName);
	}

	this.v2obs = function(key) {
		return twc.checkNull(twc.data.v2obs.observation[key]);
	};

	this.today_DayPart = function(key) {
		return twc.checkNull(twc.data['v3-wx-forecast-daily-10day'].daypart[0][key][twc.dayPartIndex]);
	};

	this.today = function(key) {
		return twc.checkNull(twc.data['v3-wx-forecast-daily-10day'][key][0]);
	};

	this.forecast_DayPart = function(key, index) {
		return twc.checkNull(twc.data['v3-wx-forecast-daily-10day'].daypart[0][key][index]);
	};

	this.forecast = function(key, index) {
		return twc.checkNull(twc.data['v3-wx-forecast-daily-10day'][key][index]);
	};

	this.hourly = function(key, index) {
		return twc.checkNull(twc.data['v3-wx-forecast-hourly-2day'][key][index]);
	};

	this.get10DayLength = function() {
		return twc.data['v3-wx-forecast-daily-10day']['dayOfWeek'].length;
	}

	//private
	this.checkNull = function(value) {
		return (value != null) ? value : '-';
	}

	this.checkLocationNull = function(value) {
		return (value != null) ? value : '不明';
	}
};